var Observable = require("FuseJS/Observable");

var basicMoney = 0;
var lowerPercent = 0;
var items = Observable();
var hangul_price = Observable();
var maxPrice = Observable();
var minPrice = Observable();
var avgPrice = Observable();
var ranPrice = Observable();

var minPercentage = Observable("");
var maxPercentage = Observable("");









var switchTop = 1.02;
var switchDown = 0.98;

function addItem() {
	items.add({ text: RandomPrice() });
	//RandomPrice();
}

function removeItem(sender) {
	items.remove(sender.data);
}



// Number.prototype.format = function (args) {
// 	if (args.value.toString.length==0) {
// 		return 0;
// 	}

// 	var reg = /(^[+-]?\d+)(\d{3})/;
//     var n = (args.value.toString() + '');
 
//     while (reg.test(n)) n = n.replace(reg, '$1' + ',' + '$2');
 
//     return n;

// }
function numberWithCommas(x) {
    return x.value.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ",");
}






function priceToHangul(args){

	basicMoney = args.value.toString().replace(/,/gi, ""); 
	console.log("First basic price = "+basicMoney);

	basicMoney = parseFloat(basicMoney);
	console.log("args.toString " + args.value.toString());

	console.log("Second basic price = "+basicMoney);
	
	if (args.value==null) return '영';
	var phonemic = ['','일','이','삼','사','오','육','칠','팔','구'];
	var unit = ['','','십','백','천','만','십만','백만','천만','억','십억','백억','천억','조','십조','백조'];
	var ret = '';
	var part = new Array();
	for (var x=0; x<String(args.value.replace(/,/gi, "")).length; x++) part[x] = String(args.value.replace(/,/gi, "")).substring(x,x+1);
	
	for (var i=0, cnt = String(args.value.replace(/,/gi, "")).length; cnt > 0; --cnt,++i) {
		p = phonemic[part[i]];
		p+= (p) ? (cnt>4 && phonemic[part[i+1]]) ? unit[cnt].substring(0,1) : unit[cnt] : '';
		ret+= p;
	}
	ret+= "원";
	//console.log(ret);
	hangul_price.value = ret;

	


	calcPrice();

	console.log("numberWithCommas : " + numberWithCommas(args));

	
	

	

}

function getLowerPercents(args){
	lowerPercent = parseFloat(args.value);
	calcPrice();
}

function getSwitchOne(args){
	if(args.value==true){
		console.log("getSwitchOne args.value : " + args.value);
		switchTop = 1.02;
		switchDown = 0.98;
	}
	calcPrice();
}

function getSwitchTwo(args){
	if(args.value==true){
		console.log("getSwitchTwo args.value : " + args.value);
		switchTop = 1.03;
		switchDown = 0.97;
	}
	calcPrice();
}

function getSwitchThree(args) {

	if(args.value==true) {
		console.log("getSwitchThree args.value : " + args.value);
		switchDown = 1 - ((0.01) * minPercentage.value);
		switchTop = 1 + ((0.01) * maxPercentage.value);
		console.log("getSwitchThree switchDown : " + switchDown);
		console.log("getSwitchThree switchTop : " + switchTop)
	}

	calcPrice();
}

function calcPrice(){
	var tempMax=0;
	var tempMin=0;
	var tempAvg=0;

	tempMax = basicMoney * lowerPercent * 0.01 * switchTop;
	maxPrice.value = String(parseInt(tempMax)) +"원";
	
	tempMin = basicMoney * lowerPercent * 0.01 * switchDown;
	minPrice.value = String(parseInt(tempMin)) +"원";

	tempAvg = (tempMax + tempMin)/2;
	avgPrice.value = String(parseInt(tempAvg)) +"원";

	console.log("max price = "+maxPrice.value);
	console.log("min price = "+minPrice.value);
	console.log("avg price = "+avgPrice.value);
}

function RandomPrice(){
	var temp;
	var t = Math.random();
	console.log(t);
	temp= (t * (switchTop-switchDown) + switchDown) * basicMoney * lowerPercent * 0.01;
	ranPrice.value = String(parseInt(temp)) +"원";
	console.log("random price = "+ranPrice);

	return ranPrice.value;
}

module.exports = {
	items: items,
	addItem: addItem,
	removeItem: removeItem,
	priceToHangul: priceToHangul,
	hangul_price: hangul_price,
	getSwitchOne: getSwitchOne,
	getSwitchTwo: getSwitchTwo,
	getSwitchThree: getSwitchThree,
	maxPrice: maxPrice,
	minPrice: minPrice,
	avgPrice: avgPrice,
	minPercentage: minPercentage,
	maxPercentage: maxPercentage,
	getLowerPercents: getLowerPercents,
	numberWithCommas: numberWithCommas
};